Форум программистов, компьютерный форум, киберфорум
Наши страницы

С++ для начинающих

Войти
Регистрация
Восстановить пароль
 
 
Tiva
94 / 94 / 1
Регистрация: 25.04.2012
Сообщений: 429
#1

try catch throw для чего нужны? - C++

26.02.2013, 15:58. Просмотров 1204. Ответов 17
Метки нет (Все метки)

Для чего нужны эти операторы?
Линканите пожалуйста статью, где доходчиво объяснено их применение, в разных вариантах
(например я видел throw без остальных конструкций, а в статьях такого описания нету)
0
Надоела реклама? Зарегистрируйтесь и она исчезнет полностью.
Similar
Эксперт
41792 / 34177 / 6122
Регистрация: 12.04.2006
Сообщений: 57,940
26.02.2013, 15:58
Здравствуйте! Я подобрал для вас темы с ответами на вопрос try catch throw для чего нужны? (C++):

Try - catch - throw для чего они - C++
Есть код программы принимающей температуру и заводит в вектор, она еще не доработана, Страуструп пишет что защиту от ошибок можно сделать с...

Try, catch, throw - C++
Подскажите, как с помощью try, catch, throw, обработать исключение на вводимый тип данных? Например, допускается только тип int, что...

try-throw-catch - C++
#include <iostream> #include <math.h> using namespace std; class Drob { public: int obchuslennia (int a, int...

try, catch, throw - C++
пишу класс namespace mystd { const uint32_t def_size = 1 << 20; //default memory container template<typename T> ...

throw, try, catch - C++
Пожалуйста, помогите разобраться в том, что это такое, и как его правильно использовать. Где можно об этом почитать? P.S. только начал...

Try..catch..Throw - C++
Объясните пожалуйста разницу. Желательно с примерами, например деление на ноль, ну или чтобы было сразу несколько исключений. Расскажите...

17
Croessmah
Ушел
Эксперт CЭксперт С++
13553 / 7704 / 872
Регистрация: 27.09.2012
Сообщений: 19,006
Записей в блоге: 3
Завершенные тесты: 1
26.02.2013, 16:04 #2
Для обработки исключений
0
Issues
430 / 365 / 37
Регистрация: 06.08.2012
Сообщений: 961
26.02.2013, 16:05 #3
для обработки исключений.

Добавлено через 16 секунд

Не по теме:

опоздал.

0
Croessmah
Ушел
Эксперт CЭксперт С++
13553 / 7704 / 872
Регистрация: 27.09.2012
Сообщений: 19,006
Записей в блоге: 3
Завершенные тесты: 1
26.02.2013, 16:06 #4
Использование исключительных ситуаций C++ для обработки ошибок
0
Develops
15 / 15 / 1
Регистрация: 19.02.2013
Сообщений: 40
26.02.2013, 16:28 #5
Немного убогий пример приведу.
Например программа генерирует случайные числа в диапазоне от 0 до 50. Нем необходимы числа больше 20. Числа, меньше 20 у нас будут исключениями, которые мы так же сможем обработать.
Рассмотрим код следующей программы:
C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
#include <iostream>
#include <math.h>
 
using namespace std;
 
int main()
{
   void func(void);
   func();
   return 0;
}
 
void func(void)
{
    int num;
    try
    {
        num = rand(); // Чтобы не усложнять код, представим, что rand генерирует число именно в нужном нам промежутке.
        if(num < 20)
            throw num; // Если число меньше 20, генерируем исключение. Выполнение кода в блоке try {...} прерывается.
        // В ином случае продолжаем работу со сгенерированным числом.
        cout << "Наше число: " << num << endl;
    }
    catch(int n) // В этом блоке мы ловим исключение и делаем с ним что хотим. Например, выводим оповещение.
    {
        cout << "Слишком маленькое число: " << n << endl;
    }
}
К сожалению, про throw без блоков try и catch в c++ я рассказать ничего не могу.
Вообще, вот неплохая статья по теме.

Добавлено через 1 минуту
Тоже опоздал
1
IGPIGP
Комп_Оратор)
Эксперт по математике/физике
6503 / 3142 / 307
Регистрация: 04.12.2011
Сообщений: 8,673
Записей в блоге: 5
26.02.2013, 16:57 #6
Tiva, в простой ситуации, например при опасности деления на 0, можно самостоятельно проверить знаменатель и обработать ситуацию. Можно выдать сообщение, которое подскажет, ошибку и пригласить ввести новое значение и т.п. В случае когда вызывается библиотечная функция с большим количеством аргументов, причину сбоя предусмотреть труднее, особенно учитывая, что сбой может возникнуть по ряду причин от программы не зависящих: неготовность устройства, не выделение памяти и др. Тогда и сбой возникает в коде к которому нет доступа, например в ядре OS. Однако хорошие функции и классы имеют документацию, в которой описаны исключения, которые они генерируют. В этом случае например, механизм исключений дает возможность проанализировать причину, выдать сообщение, предотвратить крэш.
0
Kastaneda
Jesus loves me
Эксперт С++
4689 / 2893 / 236
Регистрация: 12.12.2009
Сообщений: 7,356
Записей в блоге: 2
Завершенные тесты: 1
26.02.2013, 19:02 #7
Цитата Сообщение от IGPIGP Посмотреть сообщение
в простой ситуации, например при опасности деления на 0
более того - деление на 0 нельзя обработать при помощи try {} cath().
0
HighPredator
5544 / 1857 / 346
Регистрация: 10.12.2010
Сообщений: 5,479
Записей в блоге: 2
26.02.2013, 19:24 #8
Цитата Сообщение от Kastaneda Посмотреть сообщение
деление на 0 нельзя обработать при помощи try {} cath()
Можно, если установить соответствующим образом транслятор исключений из структурных в типизированные.
2
Kastaneda
Jesus loves me
Эксперт С++
4689 / 2893 / 236
Регистрация: 12.12.2009
Сообщений: 7,356
Записей в блоге: 2
Завершенные тесты: 1
26.02.2013, 19:57 #9
Цитата Сообщение от HighPredator Посмотреть сообщение
Можно, если установить соответствующим образом транслятор исключений из структурных в типизированные.
Можно пример?
0
HighPredator
5544 / 1857 / 346
Регистрация: 10.12.2010
Сообщений: 5,479
Записей в блоге: 2
26.02.2013, 20:30 #10
Kastaneda, Что возвращать при делении на ноль?
1
Kastaneda
Jesus loves me
Эксперт С++
4689 / 2893 / 236
Регистрация: 12.12.2009
Сообщений: 7,356
Записей в блоге: 2
Завершенные тесты: 1
26.02.2013, 21:05 #11
Ну я так и думал, что это что-то ОС специфичное - просто сторонняя плюшка для С++.
Но все равно пример интересный, раньше такого не видел.
0
IGPIGP
Комп_Оратор)
Эксперт по математике/физике
6503 / 3142 / 307
Регистрация: 04.12.2011
Сообщений: 8,673
Записей в блоге: 5
26.02.2013, 21:27 #12
Цитата Сообщение от Kastaneda Посмотреть сообщение
Можно пример?
C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
//VS2008 -> Свойства проекта -> C/C++ -> Cоздание кода -> Да, с SEH исключениями (/EHa)
#include <iostream>
#include <Cmath>
using namespace std;
int main()
{
int a=1;
int b=0;
int c=0;
 
try{
c=a/b;
    //b=log(a);
}
catch(...){
cerr<<" Ai! "<<endl;//Ai!
}
cout<<endl;
system("pause");
return 0;
}
0
Kastaneda
Jesus loves me
Эксперт С++
4689 / 2893 / 236
Регистрация: 12.12.2009
Сообщений: 7,356
Записей в блоге: 2
Завершенные тесты: 1
26.02.2013, 21:35 #13
Да, про /EHa я уже почитал.

[занудство]
все равно в С++ нельзя отловить деление на 0 при помощи try{} catch(), в привиденых примерах это делается средствами определенного компилятора, пр-ва microsoft, который в свою очередь генерит специфичный для винды код, вместо обычного try{} catch()
[/занудство]

Не по теме:

а вот это

C++
1
#include <Cmath>
делает код совсем не переносимым

0
HighPredator
26.02.2013, 21:53
  #14

Не по теме:

Kastaneda, а что делать, если по стандарту языка деление на ноль - undefined behaviour...

1
IGPIGP
Комп_Оратор)
Эксперт по математике/физике
6503 / 3142 / 307
Регистрация: 04.12.2011
Сообщений: 8,673
Записей в блоге: 5
26.02.2013, 21:57 #15
Цитата Сообщение от Kastaneda Посмотреть сообщение
C++
1
#include <Cmath>
делает код совсем не переносимым[/OFF]
Да, я пробовал логарифм отрицательного числа, потом что-то изменил, а что-то закоментил, а эту строку забыл. Занудство.
Заголовок топика, как я понял, не предполагает дискуссий о иерархиях классов исключений, для каскадной обработки. Разве существенно, конкретно, как обработать тот или иной тип, когда вопрос задан вообще?
0
26.02.2013, 21:57
MoreAnswers
Эксперт
37091 / 29110 / 5898
Регистрация: 17.06.2006
Сообщений: 43,301
26.02.2013, 21:57
Привет! Вот еще темы с ответами:

Try,catch,throw,OVERFLOW! - C++
Добрый вечер! И СНОВА с вами try..catch...:p Я очень долго пытался понять try-catch сам, читал везде, где только можно(ссылки давать...

Try Throw Catch пример - C++
Как-то не особо много инфы нарыл по данной теме... Может у кого есть какие уже реализованные примеры?

C++ try catch throw в разных функциях - C++
try и catch находятся в одной функции а throw вызывается из другой. ну MVS выкидывает исключение вместо передачи управления. что делать?...

try, throw, catch...обработка исключений - C++
помогите разобраться с обработкой исключений...при вводе пароля больше 10 символов должна быть непредвиденная ошибка, пытаюсь ее поймать,но...


Искать еще темы с ответами

Или воспользуйтесь поиском по форуму:
15
Ответ Создать тему
Опции темы

КиберФорум - форум программистов, компьютерный форум, программирование
Powered by vBulletin® Version 3.8.9
Copyright ©2000 - 2017, vBulletin Solutions, Inc.
Рейтинг@Mail.ru